# -*- coding: utf-8 -*-
"""
/***************************************************************************
 FeatureFilterDatasetBuilder
                                 A QGIS plugin
 Builds a dataset for the DL-featurefilter model from annotated polygons
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2021-08-19
        git sha              : $Format:%H$
        copyright            : (C) 2021 by Jonathan Gerbscheid, Het Waterschapshuis
        email                : j.gerbscheid@hetwaterschapshuis.nl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
import json
import os.path

import numpy as np
from PIL import Image
from qgis.core import (QgsField, QgsMapRendererParallelJob, QgsMapSettings,
                       QgsMessageLog, QgsProject, QgsRasterLayer, QgsRectangle,
                       QgsVectorDataProvider, QgsVectorLayer)
from qgis.PyQt.QtCore import (QCoreApplication, QPointF, QRectF, QSettings,
                              QSize, QTranslator)
from qgis.PyQt.QtGui import QColor, QIcon, QPolygonF
from qgis.PyQt.QtWidgets import QAction

# Import the code for the dialog
from .feature_filter_dataset_builder_dialog import \
    FeatureFilterDatasetBuilderDialog
# Initialize Qt resources from file resources.py
from .resources import *


class FeatureFilterDatasetBuilder:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'FeatureFilterDatasetBuilder_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&Feature Filter Dataset Builder')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None
        self.canvas = self.iface.mapCanvas()
        self.dlg = FeatureFilterDatasetBuilderDialog()

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('FeatureFilterDatasetBuilder', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/feature_filter_dataset_builder/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'Build Segmentation Dataset'),
            callback=self.run,
            parent=self.iface.mainWindow())

        # will be set False in run()
        self.first_start = True

    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&Segmentation Dataset Builder'),
                action)
            self.iface.removeToolBarIcon(action)

    def source_select(self):
        """
        Update options in field selection combobox when a new field is added.
        """
        vectorlayers = self.get_vectorlayers()
        self.dlg.field_name_selector.clear()
        selected_layer_index = self.dlg.vector_layer_selector.currentIndex()
        selected_layer = vectorlayers[selected_layer_index]
        fields = [field.name() for field in selected_layer.fields()]
        self.dlg.field_name_selector.addItems(fields)

    def populate_raster_layer_selector(self):
        """
        Add all the available raster layers to the source layer combobox.
        """
        # Fetch the currently loaded layers
        layers = QgsProject.instance().mapLayers().values()

        # Clear the contents of the sourcelayercbox from previous runs
        self.dlg.raster_layer_selector.clear()

        # Populate the comboBox with names of all the loaded layers
        rasterlayers = [layer for layer in layers if type(layer) == QgsRasterLayer]
        self.dlg.raster_layer_selector.addItems([layer.name() for layer in rasterlayers])
        QgsMessageLog.logMessage("populated rasterlayers", "ff_dataset_builder")
        QgsMessageLog.logMessage(f"{[rasterlayers]}", "ff_dataset_builder")

    @staticmethod
    def get_vectorlayers():
        """
        Get vector layers in project.
        """
        layers = QgsProject.instance().mapLayers().values()
        vectorlayers = [layer for layer in layers if type(layer) == QgsVectorLayer]
        return vectorlayers

    @staticmethod
    def get_rasterlayers():
        """
        Get vector layers in project.
        """
        layers = QgsProject.instance().mapLayers().values()
        rasterlayers = [layer for layer in layers if type(layer) == QgsRasterLayer]
        return rasterlayers

    def populate_vector_layer_selector(self):
        """
        Add all the available vecotr layers to the source layer combobox.
        """
        # Fetch the currently loaded layers
        layers = QgsProject.instance().mapLayers().values()

        # Clear the contents of the sourcelayercbox from previous runs
        self.dlg.vector_layer_selector.clear()

        # Populate the comboBox with names of all the loaded layers
        vectorlayers = [layer for layer in layers if type(layer) == QgsVectorLayer]
        self.dlg.vector_layer_selector.addItems([layer.name() for layer in vectorlayers])
        QgsMessageLog.logMessage("populated vectorlayers", "ff_dataset_builder")
        QgsMessageLog.logMessage(f"vector layers: {[vectorlayers]}", "ff_dataset_builder")

    def export_dataset(self):
        # get save location
        savepath = self.dlg.folder_selector.filePath()

        # make dataset folders
        QgsMessageLog.logMessage(f"{os.path.join(savepath, 'dl_filter_dataset')}", "ff_dataset_builder")
        os.makedirs(os.path.join(savepath, "dl_filter_dataset"), exist_ok=True)
        os.makedirs(os.path.join(savepath, "dl_filter_dataset/masks"), exist_ok=True)
        os.makedirs(os.path.join(savepath, "dl_filter_dataset/images"), exist_ok=True)

        # get the selected field and feature from the GUI.
        rasterlayers = self.get_rasterlayers()
        selected_layer_index = self.dlg.raster_layer_selector.currentIndex()
        selected_raster_layer = rasterlayers[selected_layer_index]

        vectorlayers = self.get_vectorlayers()
        selected_layer_index = self.dlg.vector_layer_selector.currentIndex()
        selected_layer = vectorlayers[selected_layer_index]

        selected_field_index = self.dlg.field_name_selector.currentIndex()
        fields = [field.name() for field in selected_layer.fields()]
        selected_field = fields[selected_field_index]

        QgsMessageLog.logMessage(f"{savepath}", "ff_dataset_builder")
        QgsMessageLog.logMessage(f"{selected_field}", "ff_dataset_builder")

        # selected_layer.selectAll()
        # selection = selected_layer.selectedFeatures()
        selection = selected_layer.getFeatures()

        # save the results of the annotation here
        annotation_dict = {}

        # loop through each feature, center the map on it and export it
        for i, feature in enumerate(selection):
            selected_layer.select(i)
            value = feature[selected_field_index]

            # for large shape files skip the features that are not yet annotated
            QgsMessageLog.logMessage(f"VALUE: {value}", "ff_dataset_builder")
            if value == 'unchecked':
                continue

            annotation_dict[str(i)] = {}
            annotation_dict[str(i)]['annotation'] = value

            # relative safepaths
            filepath_image = os.path.join("images", f"image_{i}.png")
            filepath_mask = os.path.join("masks", f"mask_{i}.png")
            annotation_dict[str(i)]['image_path'] = filepath_image
            annotation_dict[str(i)]['mask_path'] = filepath_mask

            fields = selected_layer.fields()
            fields.indexFromName('fieldName')

            perimeter = feature.geometry().length()
            area = feature.geometry().area()

            centroid = feature.geometry().centroid().asPoint()

            annotation_dict[str(i)]['location_features'] = {"centroid": (centroid[0], centroid[1])}
            annotation_dict[str(i)]['geometry_features'] = {"perimeter": perimeter, "area": area}

            bbox = feature.geometry().boundingBox()
            xmax = bbox.xMaximum()
            ymax = bbox.yMaximum()
            ymin = bbox.yMinimum()
            xmin = bbox.xMinimum()
            QgsMessageLog.logMessage(f"bbox: {xmin}, {ymax}, {xmax}, {ymin}", "ff_dataset_builder")

            annotation_dict[str(i)]['geometry_features'] = {"bbox": {
                                                                    'xmax': xmax,
                                                                    'ymax': ymax,
                                                                    'ymin': ymin,
                                                                    'xmin': xmin,
                                                                    }}

            # if extent is tiny lets size it up at bit, at least 20x20m
            if (xmax - xmin) > 20:
                # get center
                x_center = xmin + ((xmax - xmin) / 2)
                y_center = ymin + ((ymax - ymin) / 2)
                xmin = x_center - 10
                xmax = x_center + 10
                ymin = y_center - 10
                ymax = y_center + 10

            extent = QgsRectangle(xmin, ymin, xmax, ymax)

            # vlayer = self.iface.activeLayer()
            settings = QgsMapSettings()
            settings.setLayers([selected_raster_layer])
            settings.setBackgroundColor(QColor(0, 0, 0))
            settings.setOutputSize(QSize(128, 128))
            settings.setExtent(extent)

            render = QgsMapRendererParallelJob(settings)

            settings = QgsMapSettings()
            settings.setLayers([selected_layer])
            settings.setBackgroundColor(QColor(0, 0, 0))
            settings.setOutputSize(QSize(128, 128))
            settings.setExtent(extent)

            render2 = QgsMapRendererParallelJob(settings)

            def finished_image():
                img = render.renderedImage()
                filepath = os.path.join(savepath, "dl_filter_dataset", "images", f"image_{i}.png")
                QgsMessageLog.logMessage("saving: " + filepath, "ff_dataset_builder")
                img.save(filepath, "png")

            def finished_mask():
                img2 = render2.renderedImage()
                filepath = os.path.join(savepath, "dl_filter_dataset", "masks", f"mask_{i}.png")
                QgsMessageLog.logMessage("saving" + filepath, "ff_dataset_builder")
                img2.save(filepath, "png")

                # idk how to change the imge while in it is still in Qimage format so i'll just read it and change it here
                # we're also going to delete all the features that are not selected by filtering color
                with Image.open(filepath, mode="r") as im:
                    arr = np.array(im)
                    arr = arr[:, :, :3]

                    mask = arr[:, :, 0] + arr[:, :, 1] + arr[:, :, 2]
                    mask[(mask > 10)] = 255
                    mask[(mask < 10)] = 0
                    # # change the yellow to white
                    # arr[:, :, 2] = arr[:, :, 1]
                    # remove all grey pixels (non selected features basically)
                    # arr[arr < 100] = 0
                    arr[:, :, 0] = mask
                    arr[:, :, 1] = mask
                    arr[:, :, 2] = mask

                    # save over the original image
                    img = Image.fromarray(arr)
                    img.save(filepath)

            render.finished.connect(finished_image)
            render2.finished.connect(finished_mask)

            # Start the rendering
            render.start()
            render.waitForFinished()

            render2.start()
            render2.waitForFinished()
            selected_layer.removeSelection()

        # save annotation data to dataset as json file
        with open(os.path.join(savepath, "dl_filter_dataset/annotation.json"), 'w') as outfile:
            json.dump(annotation_dict, outfile, sort_keys=True, indent=4)

        QgsMessageLog.logMessage("Done!", "ff_dataset_builder")

    def run(self):
        """Run method that performs all the real work"""

        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start:
            self.first_start = False

            # connect all buttons
            self.dlg.vector_layer_selector.currentIndexChanged.connect(self.source_select)
            self.dlg.build_dataset.clicked.connect(self.export_dataset)

        # add vectorlayers
        self.populate_vector_layer_selector()
        self.populate_raster_layer_selector()

        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            # Do something useful here - delete the line containing pass and
            # substitute with your code.
            pass
